/**	\file
	<b>some tools</b><br>
	Autor: Matthias Weier<br>
	Copyright 2005: Matthias Weier<br>
	License: QPL (see license.txt)
	<hr>
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>

#include "tools.h"

volatile unsigned char t1_tick;
unsigned char t1_cnt;

//Konstanten im EEPROM
#define EEPROM  __attribute__ ((section (".eeprom")))

//Variablen im EEPROM
EEPROM unsigned char eeprom_sck_period=10;

ISR(SIG_OUTPUT_COMPARE1A)
{
  t1_tick=1;
  t1_cnt++;
}

unsigned char get_t1_tick(void)
{
  if (t1_tick)
    {
      t1_tick=0;
      return 1;
    }
  return 0;
}

/**
	Wartet n*1ms - 1ms max.
*/
void wait_ms(unsigned int n)
{
  while (n)
    {
      if (get_t1_tick()) n--;
    }
}
